#include "installer.h"
struct tgt_object *stringpass1, *stringpass2, *stringadmin, *stringdc1, *stringdc2;
int preinst1_main();
int eth_main();


/* ==== functions ==== */
void ldap_next() {
	tgt_unlink(window);
	preinst1_main();
	tgt_refresh(window);
}

void ldap_prev() {
	tgt_unlink(window);
	eth_main();
	tgt_refresh(window);
}

void saveldap() {
	char *pass1, *pass2, *dc1 ,*dc2, *admin;
	
	conf = tgt_load_conf(confile);
	
	tgt_get(stringpass1,TGTT_STRING_STRING,(tgtt*) &pass1);
	tgt_get(stringpass2,TGTT_STRING_STRING,(tgtt*) &pass2);
	tgt_get(stringdc1,TGTT_STRING_STRING,(tgtt*) &dc1);
	tgt_get(stringdc2,TGTT_STRING_STRING,(tgtt*) &dc2);
	tgt_get(stringadmin,TGTT_STRING_STRING,(tgtt*) &admin);
	
	if ( !(strcmp(pass1,pass2)) ) {
	 
	 if ( strlen(pass1) < 6 ) {
	  popupmsg("Hiba","A jelsz kevesebb mint 6 karakter !\n\n");
	 } else {
	 	 	 
	  tgt_set_conf(conf,"ldap","dc1",dc1);
	  tgt_set_conf(conf,"ldap","dc2",dc2);	 
	  tgt_set_conf(conf,"ldap","admin",admin);
	  tgt_set_conf(conf,"ldap","password",pass1);
	  tgt_save_conf(conf,confile);
	  tgt_unload_conf(conf);
	 
	  ldap_next();
	 }
	 
	} else { popupmsg("Hiba","A kt jelsz nem egyezik !\n\n"); } 
	
}

/* main window */
void step_ldap () {
	struct tgt_object *line1, *b1, *b2,	*labelpass1, *labelpass2, *labeldc1, *labeldc2, *labeladmin;

	window = tgt_createobject(TGT_CLASS_WINDOW, (tgtt[]) {
	TGTT_WINDOW_TITLE, (tgtt) "UHU-Linux - LDAP belltsa",
	TGTT_WINDOW_TITLECOLOR,3,
	TGTT_WINDOW_BORDERCOLOR,3,
	TGTT_CALLBACK, (tgtt) hotkeys,
	TGTT_XS, 78, TGTT_YS, 23,	
	TGTT_END,0});
	
	tgt_set(window, TGTT_X, (tgt_getterminal()->x_size - 78) / 2);
	tgt_set(window, TGTT_Y, (tgt_getterminal()->y_size - 23) / 2);	
	
	tgt_link(window,desktop);
	
	labeldc1 = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,12,
	TGTT_LABEL_TEXT, (tgtt) "dc1:",	
	TGTT_END,0});
	
	stringdc1 = tgt_createandlink(window,TGT_CLASS_STRING,(tgtt[]) {
	TGTT_X,24,TGTT_Y,12,TGTT_XS,15,
	TGTT_STRING_MAX,15,
	/* TGTT_STRING_ACCEPT, (tgtt) "qwertyuiopasdfghjklzxcvbnm" */
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0});
	
	labeldc2 = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,13,
	TGTT_LABEL_TEXT, (tgtt) "dc2:",	
	TGTT_END,0});
	
	stringdc2 = tgt_createandlink(window,TGT_CLASS_STRING,(tgtt[]) {
	TGTT_X,24,TGTT_Y,13,TGTT_XS,15,
	TGTT_STRING_MAX,15,
	/* TGTT_STRING_ACCEPT, (tgtt) "qwertyuiopasdfghjklzxcvbnm" */
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0});
	
	labeladmin = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,14,
	TGTT_LABEL_TEXT, (tgtt) "Adminisztrtor neve:",	
	TGTT_END,0});
	
	stringadmin = tgt_createandlink(window,TGT_CLASS_STRING,(tgtt[]) {
	TGTT_X,24,TGTT_Y,14,TGTT_XS,15,
	TGTT_STRING_MAX,15,
	TGTT_STRING_ACCEPT, (tgtt) "qwertyuiopasdfghjklzxcvbnm",
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0});	
	
	/* passwords */
	labelpass1 = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,15,
	TGTT_LABEL_TEXT, (tgtt) "Admin jelsz:",	
	TGTT_END,0});
	
	stringpass1 = tgt_createandlink(window,TGT_CLASS_STRING,(tgtt[]) {
	TGTT_X,24,TGTT_Y,15,TGTT_XS,10,
	TGTT_STRING_MAX,10,
	TGTT_STRING_HASHED,'*',
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0});
		
	labelpass2 = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,16,
	TGTT_LABEL_TEXT, (tgtt) "Mgegyszer:",	
	TGTT_END,0});
	
	stringpass2 = tgt_createandlink(window,TGT_CLASS_STRING,(tgtt[]) {
	TGTT_X,24,TGTT_Y,16,TGTT_XS,10,
	TGTT_STRING_MAX,10,
	TGTT_STRING_HASHED,'*',
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0});
	
	/* buttons */
	line1 = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,1,TGTT_Y,20,
	TGTT_LABEL_TEXT, (tgtt) "----------------------------------------------------------------------------",	
	TGTT_END,0});
	
	b2 = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,58,TGTT_Y,21,
	TGTT_BUTTON_CAPTION, (tgtt) "  Ok  ",
	TGTT_CALLBACK, (tgtt) saveldap,
	TGTT_BG,1,
	TGTT_END,0});
	
	b1 = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) { 
	TGTT_X,16,TGTT_Y,21,
	TGTT_BUTTON_CAPTION, (tgtt) " Vissza ",
	TGTT_CALLBACK, (tgtt) ldap_prev,
	TGTT_BG,1,
	TGTT_END,0});
	
}

int ldap_main() {
	helpnum = 12;
	step_ldap();
	textarea("/usr/share/uhu-console-installer/text_ldap");
	tgt_setfocus(stringdc1);
	
	return(0);
}
