#include "installer.h"
#include <pty.h>
#include <utmp.h>
#include <unistd.h>
#include <sys/mount.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <errno.h>
#include <signal.h>
#include <fcntl.h>
#include <linux/fs.h>
#include "packages.h"


void installgo();
void pbar();
void step_preinst1();
void step_pbar();
void getpack();
int filecopy();
struct tgt_object *progressbar, *log, *packs, *percent, *desc, *packsize, *time, *packfullsize, *allsize;
char *targetpoint;
int xconfig_main();

/* ==== functions ==== */
void preinst1_next() {
	tgt_unlink(window);
	installgo();
	tgt_refresh(window);
}

void preinst1_prev() {
	tgt_unlink(window);
	xconfig_main();
	tgt_refresh(window);
}

/* void the_end() {
	struct tgt_object *label;
	int i,j;
	
	char *felirat[] = {"   FEJLESZTOK",
	"Mezei Gabor dragon@uhulinux.hu",
	"Kovacs Andras grobs@uhulinux.hu",
	"Kormendi Andras andras@uhulinux.hu",
	"Domsodi Gergely doome@uhulinux.hu",
	"Pozsar Balazs pozsy@uhulinux.hu",
	};
	
	window = tgt_createobject(TGT_CLASS_WINDOW, (tgtt[]) {
	TGTT_WINDOW_TITLE, (tgtt) "UHU-Linux - JUHHU",
	TGTT_WINDOW_TITLECOLOR,3,
	TGTT_WINDOW_BORDERCOLOR,3,
	TGTT_CALLBACK, (tgtt) hotkeys,
	TGTT_XS, 75, TGTT_YS, 21,	
	TGTT_END,0 
	});
	
	tgt_set(window, TGTT_X, (tgt_getterminal()->x_size - 75) / 2);
	tgt_set(window, TGTT_Y, (tgt_getterminal()->y_size - 20) / 2);	
	
	tgt_link(window,desktop);
	
	label = tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,25,TGTT_Y,9,	
	TGTT_END,0});
		
	tgt_refresh(desktop);
		
	 for (j = 0; j<6; j++) {
	 tgt_set(label,TGTT_LABEL_TEXT,(tgtt) felirat[j]);
	 usleep(150000);
	 tgt_set(label,TGTT_FG,6);
	 tgt_refresh(label);
	 sleep(1);
	 tgt_set(label,TGTT_FG,4);
	 tgt_refresh(label);
	 sleep(1);
	  
	 for(i = 40; i>1; i--) {
	  tgt_set(label,TGTT_X,i);
	  tgt_set(label,TGTT_LABEL_TEXT,(tgtt) felirat[j]);
	  tgt_refresh(window);
	  usleep(150000);
	 } 
	} 
	
	off(); 
	
} */

int inst_part2() {
	char *use;
	int status, fd, ksize;
	pid_t pid;
	FILE *f, *fstab;
	char tmpp[500], root[200], swap[200], stmp[500];
		
	targetpoint = getenv("TARGET");
	
	use = tgt_get_conf(conf,"part2","rootpart","default");
	
	 sprintf(tmpp,"%s",use);
	 ksize = strlen(tmpp);
	 ksize = ksize - 4;
	 tmpp[ksize] = '\0';
	
	 sprintf(swap,"%spart1",tmpp);
	 sprintf(root,"%spart2",tmpp);
	
	tgt_set(log,TGTT_LABEL_TEXT,(tgtt) "Partcionls teljes merevelemzre"); 
	tgt_refresh(log);	 
	if ((pid = fork()) < 0) { popupmsg("Hiba","Nem tudtam forkolni!\n\n"); off(); }		
	if ( pid == 0 ) {
	freopen("/tmp/install.log","a",stdout); 		  
	   sprintf(tmpp,"sfdisk -uM --force -q %s <<EOF\n0,%s,S\n,,L,*\n\n\nEOF\n",tgt_get_conf(conf,"part2","rootpart","<default>"),tgt_get_conf(conf,"part2","swapsize","<default>")); 
	   system(tmpp);
	  // if ( !(f = popen(tmpp,"r")) ) {  popupmsg("Hiba","Nem tudtam partcionlni!\n\n"); off(); }
	   //pclose(f); 
	freopen("/dev/tty","w",stdout);		
	 
	if ( (fd = open(tgt_get_conf(conf,"part2","rootpart","<default>"), O_RDONLY | O_NONBLOCK)) ) {
	  if (ioctl(fd,BLKRRPART)) { popupmsg("Hiba","Nem tudtam jraolvasni a partcikat!"); /* off(); */} 
	 
	 
	 
	 } close(fd);  exit(0); 
	} 
	while ( wait(&status) != pid );
	
	tgt_set(log,TGTT_LABEL_TEXT,(tgtt) "Root partci formzsa"); 
	tgt_refresh(log);	 		
	if ((pid = fork()) < 0) { popupmsg("Hiba","Nem tudtam forkolni!\n\n"); off(); }
	if ( pid == 0 ) {   
	freopen("/tmp/install.log","a",stdout);  		
	 /* formazas */
	 sprintf(stmp,"mke2fs -j %s",root);
	 //if ( !(f = popen(stmp,"r")) ) { popupmsg("Hiba","Nem tudtam formazni!\n\n"); off(); }
	 system(stmp);
	 exit(0);
    } 
	while ( wait(&status) != pid );	  			
	
	tgt_set(log,TGTT_LABEL_TEXT,(tgtt) "Swap formzsa"); 
	tgt_refresh(log);	 		
	if ((pid = fork()) < 0) { popupmsg("Hiba","Nem tudtam forkolni!\n\n"); off(); }
	if ( pid == 0 ) { 
	  
	 sprintf(stmp,"mkswap %s",swap);
	 if ( !(f = popen(stmp,"r")) ) { popupmsg("Hiba","Nem tudtam swap-t formzni!\n\n"); off(); }
	 pclose(f);
	 
	 tgt_set(log,TGTT_LABEL_TEXT,(tgtt) "Swap aktivlsa"); 
	 tgt_refresh(log);	 		
	 sprintf(stmp,"swapon %s",swap);
	 if ( !(f = popen(stmp,"r")) ) { popupmsg("Hiba","Nem tudtam swap-t aktivlni!\n\n"); off(); }
	 pclose(f);
	 exit(0);
	} 
	while ( wait(&status) != pid );	  			
	
	tgt_set(log,TGTT_LABEL_TEXT,(tgtt) "Root partci felcsatolsa"); 
	tgt_refresh(log);	 		
	if ((pid = fork()) < 0) { popupmsg("Hiba","Nem tudtam forkolni!\n\n"); off(); }
	if ( pid == 0 ) { 
	  
	 /* mount */
	 mount(root,targetpoint,"ext3",0,NULL);
	 exit(0);
	} 
	while ( wait(&status) != pid );	  			
		
	 /* fstab */
	 tgt_set(log,TGTT_LABEL_TEXT,(tgtt) "Fstab kitltse"); 
	 tgt_refresh(log);	 		
	 if ( (fstab = fopen("/tmp/fstab","w")) ) {
	
	 fprintf(fstab,"%s  swap\tswap\tdefaults\t0 0\n",swap);
	 fprintf(fstab,"%s  /\text3\tdefaults\t1 1\n",root);
	
	} else { popupmsg("Hiba","Nem tudtam megnyitni az fstab filet!\n\n"); off(); }
	fclose(fstab);

    return(0);	 	 
}

int inst_part3_root() {
	FILE *fstab;
	char *use;
	char p3dev[300], p3mount[100], p3type[20], p3format[2]; 
	char tmpp[400];
	
	targetpoint = getenv("TARGET");	
	
	 use = tgt_get_conf(conf,"part3","root","default");	 
	  	  
	  sscanf(use,"%[^,] ,%[^,] ,%[^,] ,%s",p3dev,p3mount,p3type,p3format);
	  
	  /* fstab */
	  tgt_set(log,TGTT_LABEL_TEXT,(tgtt) "Fstab kitltse"); 
	  tgt_refresh(log);	 		
	  if ( (fstab = fopen("/tmp/fstab","w")) ) {
	  fprintf(fstab,"%s  %s\t%s\tdefaults\t1 1\n",p3dev,p3mount,p3type);
	  } else { popupmsg("Hiba","Nem tudtam megnyitni az fstab filet!\n\n"); off(); }
	  fclose(fstab);
	  
	  /* root format -n kivenni cd */			
	  if ( !(strcmp(p3format,"1")) ) {	   
		   
	   		if ( !(strcmp(p3type,"ext3")) ) {
			 sprintf(tmpp,"mke2fs -j %s",p3dev);
	   		} else if ( !(strcmp(p3type,"ext2")) ) {
	   		  sprintf(tmpp,"mke2fs -n %s",p3dev);
			} else if ( !(strcmp(p3type,"reiserfs")) ) {
			 sprintf(tmpp,"mkreiserfs -f %s",p3dev);
			} else if ( !(strcmp(p3type,"jfs")) ) {
			 sprintf(tmpp,"mkfs.jfs -f %s",p3dev); 
	   		} else if ( !(strcmp(p3type,"xfs")) ) {
	    	 sprintf(tmpp,"mkfs.xfs %s",p3dev); 
	   		} else if ( !(strcmp(p3type,"fat32")) ) {
	    	 sprintf(tmpp,"mkfs.fat32 %s",p3dev); 
	   		} else if ( !(strcmp(p3type,"fat32")) ) {
	    	 sprintf(tmpp,"mkfs.fat16 %s",p3dev); 
	   		}
			
			tgt_set(log,TGTT_LABEL_TEXT,(tgtt) "Root partci formzsa");
	   		tgt_refresh(log);			
					
			freopen("/tmp/install.log","a",stdout);	
			system(tmpp); 
			freopen("/dev/tty","w",stdout);
					 		   
	  }	  
	     // root mount //		   
		    tgt_set(log,TGTT_LABEL_TEXT,(tgtt) "Root partci felcsatolsa");
	   		tgt_refresh(log);			
			mount(p3dev,targetpoint,p3type,0,NULL);
				   
	  return(0);
}

int inst_part3_swap() {
	FILE *fstab;
	char *use;
	char p3dev[200], p3mount[100], p3type[20], p3format[2];
	char tmpp[200], tmpp2[200];
	
	targetpoint = getenv("TARGET");	
	    		
	  use = tgt_get_conf(conf,"part3","swap","default");
	  
	  sscanf(use,"%[^,] ,%[^,] ,%[^,] ,%s",p3dev,p3mount,p3type,p3format);
	  
	  /* swap fstab */
	  if ( (fstab = fopen("/tmp/fstab","a")) ) {
	  fprintf(fstab,"%s  %s\t%s\tdefaults\t0 0\n",p3dev,p3mount,p3type);
	  } else { popupmsg("Hiba","Nem tudtam megnyitni az fstab filet!\n\n"); off(); }
	  fclose(fstab);
	  
	  /* swap format */			
	  if ( !(strcmp(p3format,"1")) ) {	   
		   
	  		 sprintf(tmpp,"mkswap %s",p3dev); 
			 sprintf(tmpp2,"swapon %s",p3dev); 
			
			 tgt_set(log,TGTT_LABEL_TEXT,(tgtt) "Swap formzsa");
	   		 tgt_refresh(log);
			
			 freopen("/tmp/install.log","a",stdout);	
			 system(tmpp); 	    
			 freopen("/dev/tty","w",stdout);					 
			 
			 // swap aktivalasa 
			 freopen("/tmp/install.log","a",stdout);	
			 system(tmpp2);     
			 freopen("/dev/tty","w",stdout);	
	    		   
	   	   } 		   
		   		   
		   return(0);	  	 	   
}	 

int inst_part3_parts() {
		FILE *fstab; /* *f */
		int i;
		char *use; /* *slog */
		char p3dev[200], p3mount[100], p3type[20], p3format[2];
		char tmpp[200];
				
		targetpoint = getenv("TARGET");
		
		tgt_set(log,TGTT_LABEL_TEXT,(tgtt) "Partcik formzsa");
	   	tgt_refresh(log);
		  
	  	i = 1;	  
	  	while(1) {
			sprintf(tmpp,"part%d",i);
			use = tgt_get_conf(conf,"part3",tmpp,"default");
						
			if ( !(strcmp(use,"default")) ) { break; }
			
			sscanf(use,"%[^,] ,%[^,] ,%[^,] ,%s",p3dev,p3mount,p3type,p3format);
		
			/* fstab */
			if ( (fstab = fopen("/tmp/fstab","a")) ) {
			fprintf(fstab,"%s  %s\t%s\tdefaults\t1 2\n",p3dev,p3mount,p3type);
			} else { popupmsg("Hiba","Nem tudtam megnyitni az fstab filet!\n\n"); off(); }
	  		fclose(fstab);	  
			
			/* format -n kivenni cd */			
		   if ( !(strcmp(p3format,"1")) ) {	   
		   
	   		if ( !(strcmp(p3type,"ext3")) ) {
			 sprintf(tmpp,"mke2fs -j %s",p3dev);
	   		} else if ( !(strcmp(p3type,"ext2")) ) {
	   		  sprintf(tmpp,"mke2fs -n %s",p3dev);
			} else if ( !(strcmp(p3type,"reiserfs")) ) {
			 sprintf(tmpp,"mkreiserfs -f %s",p3dev);
			} else if ( !(strcmp(p3type,"jfs")) ) {
			 sprintf(tmpp,"mkfs.jfs -f %s",p3dev); 
	   		} else if ( !(strcmp(p3type,"xfs")) ) {
	    		 sprintf(tmpp,"mkfs.xfs %s",p3dev); 
	   		} else if ( !(strcmp(p3type,"fat32")) ) {
	    		 sprintf(tmpp,"mkfs.fat32 %s",p3dev); 
	   		} else if ( !(strcmp(p3type,"fat32")) ) {
	    		 sprintf(tmpp,"mkfs.fat16 %s",p3dev); 
	   		}			
	   
	   
	        freopen("/tmp/install.log","a",stdout);	
			system(tmpp); 
			freopen("/dev/tty","w",stdout);
	     //if ( !(f = popen(tmpp,"r")) ) { popupmsg("Hiba","Hiba trtnt a formzskor!\n\n"); off();  }	    
		 //while ((fgets(slog,500,f)) != NULL) { fprintf(stderr,"%s",slog); }
		 //pclose(f);
				 
	  }	 
	  /* mountolas */
	     
	     sprintf(tmpp,"%s%s",targetpoint,p3mount);
		 mkdir(tmpp,00666);
		 mount(p3dev,tmpp,p3type,0,NULL);
		 //sprintf(slog,"%s",strerror(errno));
		 //stbarch(slog);			
	    
	     i++; 
	  } /* while end */
	  
	  return(0);
}

int inst_grub() {
	char *use;
	char tmp[300];
	int pid,status;
	
	use = tgt_get_conf(conf,"grub","device","default");
	
	targetpoint = getenv("TARGET");
	
	tgt_set(log,TGTT_LABEL_TEXT,(tgtt) "Grub rendszerbetlt teleptse");
	tgt_refresh(log);
	
	if ((pid = fork()) < 0) { popupmsg("Hiba","Nem tudtam forkolni!\n\n"); off(); }
	if ( pid == 0 ) { 
	
	 freopen("/tmp/install.log","a",stdout);
	 sprintf(tmp,"chroot %s grub-install %s",targetpoint,use);
	 system(tmp);
	 sprintf(tmp,"chroot %s update-grubmenu",targetpoint);
	 system(tmp);
	 freopen("/dev/tty","w",stdout);	
	 exit(0);
	
	} while ( wait(&status) != pid );
	   	  			
	
	return(0);
}

int inst_rootuser() {
	FILE *f;
	char *use;
	char tmp[300], uname[20], uuser[20], upass[20];
	int i;
	
	targetpoint = getenv("TARGET");
	use = tgt_get_conf(conf,"root","password","<default>");
			
	sprintf(tmp,"chroot %s chpasswd",targetpoint);
	if ( !(f = popen(tmp,"w")) ) { popupmsg("Hiba","Nem tudtam chrootolni!\n\n"); off(); }
	else { fprintf(f,"root:%s\n",use); } 
	pclose(f);
		
	i = 0;	  
	while(1) {
			sprintf(tmp,"user%d",i);
			use = tgt_get_conf(conf,"users",tmp,"default");
						
			if ( !(strcmp(use,"default")) ) { break; }
			
			sscanf(use,"%[^,] ,%[^,] ,%s",uuser,uname,upass);
				
			sprintf(tmp,"chroot %s useradd -m %s",targetpoint,uuser);
			system(tmp);
			
			sprintf(tmp,"chroot %s chpasswd",targetpoint);
			if ( !(f = popen(tmp,"w")) ) { popupmsg("Hiba","Nem tudtam chrootolni!\n\n"); off(); }
			else { fprintf(f,"%s:%s\n",uuser,upass); } 
			pclose(f);
			i++;
	}
	
	tgt_set(log,TGTT_LABEL_TEXT,(tgtt) "Felhasznlk hozzadva");
	tgt_refresh(desktop);
	
	return(0);
}

void inst_eth() {
	char *dns1, *dns2, *dns3, *eth, *hostname;
	char gateway[50], module[100], ip[50], netmask[50], mac[60];
	char tmp1[200], tmp2[200];
	FILE *f;
	int c = 0;
	
	targetpoint = getenv("TARGET");
	
	tgt_set(log,TGTT_LABEL_TEXT,(tgtt) "Hlzat belltsa");
	tgt_refresh(log);
	
	conf = tgt_load_conf(confile);
	
	system("mkdir -p /tmp/etc");
	
	dns1 = tgt_get_conf(conf,"eth","dns1","default");
	dns2 = tgt_get_conf(conf,"eth","dns2","default");
	dns3 = tgt_get_conf(conf,"eth","dns3","default");
	
	if ( (strcmp(dns1,"default")) ) {
	 if ( !(f = fopen("/tmp/etc/resolv.conf","w")) ) { popupmsg("Hiba","Nem tudtam megnyitni a /tmp/resolv.conf-ot!\n\n"); off(); }
	else {
	 
	 fprintf(f,"nameserver %s\n",dns1); 
	 if ( (strcmp(dns2,"default")) ) { fprintf(f,"nameserver %s\n",dns2); }
	 if ( (strcmp(dns3,"default")) ) { fprintf(f,"nameserver %s\n",dns3); }
	
	 } fclose(f);
	}
	
	hostname = tgt_get_conf(conf,"eth","hostname","default");
	if ( (strcmp(hostname,"default")) ) {
	 
	 if ( !(f = fopen("/tmp/etc/hostname","w")) ) { popupmsg("Hiba","Nem tudtam megnyitni a hostname filet!\n\n"); off(); }
	 else { fprintf(f,"%s",hostname); }
	
	} else {  fprintf(f,"localhost"); 
	} fclose(f);
	
	system("mkdir -p /tmp/etc/sysconfig/network/ethernet");
				
	while(1) {
	 sprintf(tmp1,"eth%d",c);
	 eth = tgt_get_conf(conf,"eth",tmp1,"default");
	 c++;	 
	 	 
	 if ( !(strcmp(eth,"default")) ) { break; }
	 
	  if ( (strstr(eth,"dhcp")) ) { sscanf(eth,"%[^,],dhcp,%s",module,gateway); 
	  
	   sprintf(tmp2,"/sbin/modprobe %s",module);
	   system(tmp2);
	   	  	 
	   sprintf(tmp2,"/sbin/getmac %s",tmp1);
	   if ( !(f = popen(tmp2,"r")) ) { popupmsg("Hiba","Nem tudtam futtatni a getmac parancsot!\n\n"); off(); }
	   else { 
	    fscanf(f,"%s",mac);		
	    sprintf(tmp2,"mkdir -p /tmp/etc/sysconfig/network/ethernet/%s/ipv4",mac);
	    system(tmp2);
	    fclose(f);
			
		sprintf(tmp2,"/tmp/etc/sysconfig/network/ethernet/%s/ipv4/DHCP",mac);
	    f = fopen(tmp2,"w"); fclose(f);
	  
	    sprintf(tmp2,"/tmp/etc/sysconfig/network/ethernet/%s/AUTO",mac);
	    f = fopen(tmp2,"w"); fclose(f);
		
		if ( (strlen(gateway)) != 0 ) {	  
	   sprintf(tmp2,"/tmp/etc/sysconfig/network/ethernet/%s/ipv4/gateway",mac);
	   f = fopen(tmp2,"w");	  
	   fprintf(f,"%s",gateway);
	   fclose(f);
	  }
	   } 
	  
	 } else { sscanf(eth,"%[^,],%[^,],%[^,],%s",module,ip,netmask,gateway); 
	  	  	  
	  sprintf(tmp2,"/sbin/modprobe %s",module);
	  system(tmp2);	  
	  	 
	 sprintf(tmp2,"/sbin/getmac %s",tmp1); 
	 if ( !(f = popen(tmp2,"r")) ) { popupmsg("Hiba","Nem tudtam futtatni a getmac parancsot!\n\n"); off(); }
	 else { 
	  fscanf(f,"%s",mac);
	  sprintf(tmp2,"mkdir -p /tmp/etc/sysconfig/network/ethernet/%s/ipv4",mac);
	  system(tmp2);
	  fclose(f);	  
	  
	  sprintf(tmp2,"/tmp/etc/sysconfig/network/ethernet/%s/AUTO",mac);
	  f = fopen(tmp2,"w"); fclose(f);	  
	  
	  sprintf(tmp2,"/tmp/etc/sysconfig/network/ethernet/%s/ipv4/address",mac);
	  f = fopen(tmp2,"w");	  
	  fprintf(f,"%s",ip);
	  fclose(f);
			  
	  sprintf(tmp2,"/tmp/etc/sysconfig/network/ethernet/%s/ipv4/netmask",mac);
	  f = fopen(tmp2,"w");	  
	  fprintf(f,"%s",netmask);
	  fclose(f);	  
	  
	  if ( (strlen(gateway)) != 0 ) {	  
	   sprintf(tmp2,"/tmp/etc/sysconfig/network/ethernet/%s/ipv4/gateway",mac);
	   f = fopen(tmp2,"w");	  
	   fprintf(f,"%s",gateway);
	   fclose(f);
	  }	 
	 
	 } 
	}
   }	
   
   /* felmasolas */
   sprintf(tmp2,"cp -a /tmp/etc %s",targetpoint);
   system(tmp2);
}

void inst_ldap() {
	char *admin, *dc1, *dc2, *password;
	char tmp[200];
	FILE *f;
	
	conf = tgt_load_conf(confile);
	targetpoint = getenv("TARGET");
	
	tgt_set(log,TGTT_LABEL_TEXT,(tgtt) "LDAP belltsa");
	tgt_refresh(log);
	
	dc1 = tgt_get_conf(conf,"ldap","dc1","default");
	dc2 = tgt_get_conf(conf,"ldap","dc2","default");
	admin = tgt_get_conf(conf,"ldap","admin","default");
	password = tgt_get_conf(conf,"ldap","password","default");
	
	/* slapd.conf beallitasa */
	system("cp /usr/share/uhu-console-installer/slapd.conf /tmp");
	if ( !(f = fopen("/tmp/slapd.conf","a")) ) { popupmsg("Hiba","Nem tudtam megnyitni a /tmp/slapd.conf filet!\n\n"); off(); }
	else {
		fprintf(f,"suffix\t\"dc=%s,dc=%s\"\n",dc1,dc2); 
		fprintf(f,"rootdn\t\"cn=%s,dc=%s,dc=%s\"\n\n",admin,dc1,dc2);

		fprintf(f,"access to attribute=userPassword\n");
        fprintf(f,"by dn=\"cn=%s,dc=%s,dc=%s\" write\n",admin,dc1,dc2);
        fprintf(f,"by self write\nby anonymous auth\nby * none\n\n");

		fprintf(f,"access to attribute=davPassword\n");
        fprintf(f,"by dn=\"cn=%s,dc=%s,dc=%s\" write",admin,dc1,dc2);
        fprintf(f,"by self write\nby anonymous auth\nby * none\n\n");

		fprintf(f,"access to attribute=mailPassword\n");
        fprintf(f,"by dn=\"cn=%s,dc=%s,dc=%s\" write",admin,dc1,dc2);
        fprintf(f,"by self write\nby anonymous auth\nby * none\n\n");

		fprintf(f,"access to attribute=squidPassword\n");
        fprintf(f,"by dn=\"cn=%s,dc=%s,dc=%s\" write",admin,dc1,dc2);
        fprintf(f,"by self write\nby anonymous auth\nby * none\n\n");	
	} fclose(f);
	sprintf(tmp,"cp /tmp/slapd.conf %s/etc/ldap/slapd.conf",targetpoint);
	system(tmp);	
	
	/* slapadd */
	sprintf(tmp,"chroot %s /usr/sbin/slapadd",targetpoint);
	
	if ( !(f = popen(tmp,"w")) ) { fprintf(stderr,"HIBA: Nem tudtam futtatni a slapadd parancsot!\n"); }
	else {
			
		fprintf(f,"dn: dc=%s,dc=%s\n",dc1,dc2);
		fprintf(f,"objectclass: dcObject\n");
		fprintf(f,"objectclass: organization\n");
		fprintf(f,"o: %s\n",dc1);
		fprintf(f,"dc: %s\n",dc1);
		
		fprintf(f,"dn: cn=%s,dc=%s,dc=%s\n",admin,dc1,dc2);
		fprintf(f,"objectclass: organizationalRole\n");
		fprintf(f,"objectclass: SimpleSecurityObject\n");
		fprintf(f,"cn: %s\n",admin);
		fprintf(f,"userPassword: %s\n",password);
		
		fprintf(f,"dn: cn=root,dc=%s,dc=%s\n",dc1,dc2);
		fprintf(f,"objectclass: organizationalRole\n");
		fprintf(f,"objectclass: SimpleSecurityObject\n");
		fprintf(f,"cn: root\n");
		fprintf(f,"userPassword: root\n");
		
		fprintf(f,"dn: o=Users,dc=%s,dc=%s\n",dc1,dc2);
		fprintf(f,"objectclass: organization\n");
		fprintf(f,"o: Users\n");
		
		fprintf(f,"dn: o=Groups,dc=%s,dc=%s\n",dc1,dc2);
		fprintf(f,"objectclass: organization\n");
		fprintf(f,"o: Groups\n");		
	} pclose(f);
	
}

void installgo() {
	char *use;
		
	/* kernel uzenetek elnyomasa */
	system("sysctl -w kernel.printk=0 > /dev/null");
	freopen("/tmp/install.log","w",stderr);
	
	conf = tgt_load_conf(confile);
	
	use = tgt_get_conf(conf,"part2","rootpart","default");
		
	if ( (strcmp(use,"default")) ) { inst_part2();	} 
	
	use = tgt_get_conf(conf,"part3","root","default");
	 
	if ( (strcmp(use,"default")) ) { inst_part3_root();	inst_part3_parts(); }
	
	use = tgt_get_conf(conf,"part3","swap","default");
	
	if ( (strcmp(use,"default")) ) { inst_part3_swap(); }
	
	pbar();
	
	tgt_unlink(window);
	step_preinst1();
	tgt_refresh(window);
	
	if ( server_edition == 1 ) { inst_eth(); inst_ldap(); }
	if ( firewall_edition == 1) { inst_eth(); }
		
	inst_rootuser();
			
	inst_grub();
	
	popupmsg("JUHHU","   THE END   \n\n"); off();
	//tgt_unlink(window);
	//the_end();
	//tgt_refresh(desktop);
	 
}

/* progress bar */
void pbar() {
	FILE *f;
	char tmp[200], *use;
	char a[100],b[100],c[100] = "csomag desc", d[100];
	int i,j,size,pid, status;
	long int full = 0,pvalue = 0, fullsize = 0;
	float v = 0.0, pvaluesize = 0.0, pvaluesizetmp = 0.0;
		
	targetpoint = getenv("TARGET");	
	conf = tgt_load_conf(confile);
	
	use = tgt_get_conf(conf,"packs","packfile","default");
	
	/* csomag structura kitoltese az infok vegett */
	getpack();
	
	tgt_unlink(window);
	step_pbar();
	tgt_refresh(desktop);
	//tgt_async_waitkeys(window);
			
	if ( !(f = fopen(use,"r")) ) { popupmsg("Hiba","Nem tudtam megyitni a uhu-packages.conf filet!\n\n"); off(); }
	else {
	 
	 while ( (fgets(a,100,f)) != NULL ) { full++; 
		sscanf(a,"%[^_]",b);
		
		for(i = 0; i<SECTMAX; i++) {
	    for(j = 0; j<packages[i].sectnum; j++) {
		 
		 if ( !(strcmp(b,packages[i].packname[j])) ) { 
		   fullsize = fullsize + packages[i].installedsize[j]; 
		 }
		
		}
	   }
	
	 }
	}
	sprintf(d,"%d",(int)(fullsize / 1024));
	tgt_set(allsize,TGTT_LABEL_TEXT,(tgtt) d);
	tgt_set(progressbar,TGTT_PROGRESS_ENDVALUE,fullsize);
	
	
	/* preinstall */
	tgt_set(desc,TGTT_LABEL_TEXT,(tgtt) "Preinstall");  
	tgt_refresh(desc);
	system("/usr/share/uhu-console-installer/preinstall");
		
	/* packfile megnyitasa */	
	if ( !(f = fopen(use,"r")) ) { popupmsg("Hiba","Nem tudtam megnyitni az uhu-packages.conf filet!\n\n"); off(); }	
	else {	
	
	 while ( (fgets(a,100,f)) != NULL) {
	  sscanf(a,"%[^_]",b);
	
	   for(i = 0; i<SECTMAX; i++) {
	    for(j = 0; j<packages[i].sectnum; j++) {
		 
		 if ( !(strcmp(b,packages[i].packname[j])) ) {
		  tgt_set(packs,TGTT_LABEL_TEXT,(tgtt) b);  
	      strncpy(c,packages[i].description[j],60);
		  tgt_set(desc,TGTT_LABEL_TEXT,(tgtt) c);
		  
		  size = packages[i].installedsize[j]; 
		  sprintf(d,"%d",size);
	   	  tgt_set(packsize,TGTT_LABEL_TEXT,(tgtt) d);	  
	      tgt_refresh(packsize); 
		  
		  v = v + ((float)size/fullsize) * 100;
		  pvalue = pvalue + size;
		  pvaluesizetmp = pvaluesizetmp + (float)packages[i].installedsize[j]; 
		  pvaluesizetmp = pvaluesizetmp / 1024;
		  pvaluesize = pvaluesize + pvaluesizetmp;
		  break;
  		 }
		 		
		}
	   } tgt_refresh(window);
	   		   
	   if ( (pid = fork()) < 0) { perror("fork"); }
	   if ( pid == 0 ) {
	   freopen("/tmp/unpack.log","a",stdout); 
	   
	   sprintf(tmp,"dpkg --root=%s --unpack /packages/%s",targetpoint,a);
	   system(tmp);
	   freopen("/dev/tty","w",stdout);  
	   exit(0);
	   } while ( wait(&status) != pid);
	   
	   /* progress bar */
	   sprintf(c,"%0.0f",v);
	   tgt_set(progressbar,TGTT_PROGRESS_VALUE,pvalue);
	   tgt_refresh(progressbar);
	   tgt_set(percent,TGTT_LABEL_TEXT,(tgtt) c);
	   tgt_refresh(percent);
	   sprintf(d,"%0.0f",pvaluesize);
	   tgt_set(packfullsize,TGTT_LABEL_TEXT,(tgtt) d);	  
	   tgt_refresh(packfullsize); 
	   
	} fclose(f);
	
   }
	   
	   /* configure */
	   pvalue = 0;
	   tgt_set(desc,TGTT_LABEL_TEXT,(tgtt) "Csomagok konfigurlsa");  
	   tgt_set(packs,TGTT_LABEL_TEXT,(tgtt) "");
	   tgt_set(progressbar,TGTT_PROGRESS_ENDVALUE,full);
	   tgt_set(progressbar,TGTT_PROGRESS_VALUE,pvalue);
	   tgt_refresh(window);
	   
	   sprintf(tmp,"dpkg --root=%s --configure -a",targetpoint);
	   if ( !(f = popen(tmp,"r")) ) { popupmsg("Hiba","Nem tudtam elinditani a csomagkonfigurlst!\n\n"); off(); }
	   else {
	   
	    while ( (fgets(a,200,f)) != NULL ) {
	     fprintf(stderr,"%s",a);
		 
	     if ( (strstr(a,"Setting up")) ) {
		   sscanf(a,"Setting up %[^ ]",b);  
		   pvalue++; 
		   pvaluesize = ((float)pvalue / full) * 100;
		   tgt_set(progressbar,TGTT_PROGRESS_VALUE,pvalue); 
		   sprintf(c,"%0.0f",pvaluesize);
		   tgt_set(percent,TGTT_LABEL_TEXT,(tgtt) c);
		   tgt_set(packs,TGTT_LABEL_TEXT,(tgtt) b);
		   tgt_refresh(progressbar);
		   tgt_refresh(percent); 
		   tgt_refresh(packs);
		  }	    
	    }
	   } pclose(f);

	tgt_set(desc,TGTT_LABEL_TEXT,(tgtt) "Postinstall");  
	tgt_refresh(desc);		
	
	if ( (pid = fork()) < 0) { perror("fork"); }
	if ( pid == 0 ) {
	freopen("/tmp/install.log","a",stdout);
	
	/* postinstall */
	
	system("/usr/share/uhu-console-installer/postinstall");	  
	
	sprintf(tmp,"%s/etc/fstab",targetpoint);
	filecopy("/tmp/fstab",tmp);
	sprintf(tmp,"cp /tmp/XF86Config-4.tmp %s/etc/X11/XF86Config",targetpoint);
	system(tmp);
	sprintf(tmp,"cp /tmp/install.log /tmp/uhu-console-installer.conf /tmp/uhu-packages.conf %s/root",targetpoint);
	system(tmp);
	freopen("/dev/tty","w",stdout);
	exit(0);	
	} while ( wait(&status) != pid);	
		  		  
} 

void step_pbar() {
	struct tgt_object *line; 
	
	window = tgt_createobject(
	TGT_CLASS_WINDOW, (tgtt[]) {
	TGTT_WINDOW_TITLE, (tgtt) "UHU-Linux - Telepts vgrehajtsa",
	TGTT_WINDOW_TITLECOLOR,3,
	TGTT_WINDOW_BORDERCOLOR,3,
	TGTT_CALLBACK, (tgtt) hotkeys,
	TGTT_XS, 78, TGTT_YS, 23,	
	TGTT_END,0 
	});
	
	tgt_set(window, TGTT_X, (tgt_getterminal()->x_size - 78) / 2);
	tgt_set(window, TGTT_Y, (tgt_getterminal()->y_size - 23) / 2);	
	
	tgt_link(window,desktop);
	
	progressbar = tgt_createandlink(window,TGT_CLASS_PROGRESS,(tgtt[]) {
	TGTT_X,2,TGTT_Y,12,
	TGTT_XS,65,
	TGTT_FG,7,
	TGTT_END,0});
	
	percent = tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,68,TGTT_Y,12,
	TGTT_FG,7,
	TGTT_END,0});
	
	tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,72,TGTT_Y,12,
	TGTT_LABEL_TEXT, (tgtt) "%",	
	TGTT_FG,7,
	TGTT_END,0});
	
	time = tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,2,TGTT_Y,8,
	TGTT_FG,6,
	TGTT_END,0});
	
	tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,2,TGTT_Y,10,
	TGTT_LABEL_TEXT, (tgtt) "Leirs:",
	TGTT_FG,6,
	TGTT_END,0});		
	
	desc = tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,10,TGTT_Y,10,
	TGTT_FG,6,
	TGTT_END,0});
	
	tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,2,TGTT_Y,9,
	TGTT_LABEL_TEXT, (tgtt) "Csomag:",
	TGTT_FG,6,
	TGTT_END,0});		
	
	packs = tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,10,TGTT_Y,9,
	TGTT_FG,6,
	TGTT_END,0});
	
	tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,2,TGTT_Y,14,
	TGTT_LABEL_TEXT, (tgtt) "Csomag mrete:",
	TGTT_FG,6,
	TGTT_END,0});		
	
	packsize = tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,17,TGTT_Y,14,
	TGTT_FG,6,
	TGTT_END,0});
	
	tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,24,TGTT_Y,14,
	TGTT_LABEL_TEXT, (tgtt) "K",
	TGTT_FG,6,
	TGTT_END,0});				
	
	tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,2,TGTT_Y,15,
	TGTT_LABEL_TEXT, (tgtt) "Eddig felmsolt csomagok mrete:",
	TGTT_FG,6,
	TGTT_END,0});		
	
	packfullsize = tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,35,TGTT_Y,15,
	TGTT_FG,6,
	TGTT_END,0});
	
	tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,40,TGTT_Y,15,
	TGTT_LABEL_TEXT, (tgtt) "M",
	TGTT_FG,6,
	TGTT_END,0});
	
	tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,2,TGTT_Y,16,
	TGTT_LABEL_TEXT, (tgtt) "Teleptend csomagok sszmrete:",
	TGTT_FG,6,
	TGTT_END,0});		
	
	allsize = tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,35,TGTT_Y,16,
	TGTT_FG,6,
	TGTT_END,0});
	
	tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,40,TGTT_Y,16,
	TGTT_LABEL_TEXT, (tgtt) "M",
	TGTT_FG,6,
	TGTT_END,0});				

	line = tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,1,TGTT_Y,20,
	TGTT_LABEL_TEXT, (tgtt) "----------------------------------------------------------------------------",	
	TGTT_END,0});
		
}

/* main window */
void step_preinst1 () {
	struct tgt_object *line1, *b1, *b2,	*text;

	window = tgt_createobject(TGT_CLASS_WINDOW, (tgtt[]) {
	TGTT_WINDOW_TITLE, (tgtt) "UHU-Linux - Telepts vgrehajtsa",
	TGTT_WINDOW_TITLECOLOR,3,
	TGTT_WINDOW_BORDERCOLOR,3,
	TGTT_CALLBACK, (tgtt) hotkeys,
	TGTT_XS, 78, TGTT_YS, 23,	
	TGTT_END,0 
	});
	
	tgt_set(window, TGTT_X, (tgt_getterminal()->x_size - 78) / 2);
	tgt_set(window, TGTT_Y, (tgt_getterminal()->y_size - 23) / 2);	
	
	tgt_link(window,desktop);
	
	text = tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,2,TGTT_Y,2,
	TGTT_LABEL_TEXT, (tgtt) "Az elzleg belltott dolgok most teleptsre kerlnek.",	
	TGTT_FG,6,
	TGTT_END,0});
	
	log = tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,2,TGTT_Y,8,
	TGTT_LABEL_TEXT, (tgtt) "",	
	TGTT_END,0});
	
	/* buttons */
	line1 = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,1,TGTT_Y,20,
	TGTT_LABEL_TEXT, (tgtt) "----------------------------------------------------------------------------",	
	TGTT_END,0});
	
	b2 = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,58,TGTT_Y,21,
	TGTT_BUTTON_CAPTION, (tgtt) "  Ok  ",
	TGTT_CALLBACK, (tgtt) installgo,
	TGTT_BG,1,
	TGTT_END,0});
	
	b1 = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,16,TGTT_Y,21,
	TGTT_BUTTON_CAPTION, (tgtt) " Vissza ",
	TGTT_CALLBACK, (tgtt) preinst1_prev,
	TGTT_BG,1,
	TGTT_END,0});
	
}

int preinst1_main() {
		
	step_preinst1();
	
	return(0);
}
